



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL点滴之编辑数据(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL点滴之编辑数据(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 06:41:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>　　数据库中的数据编辑是我们遇到的最频繁的工作，这一个随笔中我来总结一下最常用的数据编辑。</p>
<p><strong>　　select into</strong></p>
<p>　　经常遇到一种情况是，我们希望创建一个新表，表中的数据来源于原有的一个表；原有一个表，但是这个表中的数据已经很混乱，我们希望把这些数据备份出来，然后把原有的表中的数据清除，重新导入；在这些情况下我们可以使用select into语句。</p>
<p>　　如果当前用户拥有建表权限，在select语句使用关键字into可以在数据库中创建新的 表。这个语句只需要把into new_table_name加到选择出的列名之后，from关键字之前，当然数据可以来源于一个或多个表中。需要说明的是在新表中只包含select字 句中查询的到的数据，没有任何键，约束，关系。下面实例：</p>
<pre class="prettyprint linenums">
select top(10) *<br />
into new_intervalwaitssample<br />
from IntervalWaitsSample<br />
select * from new_intervalwaitssample
</pre>
<p>　　这个语句就将IntervalWaitsSample表中的前10行数据放在一个新建的表new_intervalwaitssample中。　　</p>
<p><strong>　　insert into select</strong></p>
<p>　　现在已经有这个新表了，如果我们想再从原表IntervalWaitsSample中选择一些数据插入到这个新表中呢，这时候就需要使用insert into select语句了，下面实例：</p>
<pre class="prettyprint linenums">
insert into new_intervalwaitssample<br />
select * from IntervalWaitsSample where wait_type='ASSEMBLY_LOAD'
</pre>
<p>　　这个语句就将原表IntervalWaitsSample中的所有wait_type='ASSEMBLY_LOAD'的数据插入到新表中了。</p>
<p><strong>　　insert into select union</strong></p>
<p>　　现在如果我们有一些已知的数据，想把这些数据一次性写入到目标表里面，应该怎么办呢，这时候union语句就很有用了，可以使用insert<br />
into select union语句，注意这个语句和insert into<br />
select很相似，差别就在于后面的select语句使用了union把多个select连接起来。</p>
<pre class="prettyprint linenums">
insert into select value11 , value12 , value13<br />
union select value21 , value22 , value23<br />
union select  value31 , value32 , value33
</pre>
<p>　　下面是实例：</p>
<pre class="prettyprint linenums">
insert into new_intervalwaitssample<br />
select 'ASYNC_NETWORK_IO','2011-05-09 16:50:00.973','0.00' union<br />
select 'ASYNC_NETWORK_IO','2011-05-09 17:00:00.020','0.00' union<br />
select 'ASYNC_NETWORK_IO','2011-05-09 17:15:00.123','0.00' union<br />
select 'ASYNC_NETWORK_IO','2011-05-09 17:25:00.190','0.00'
</pre>
<p><strong>　　使用表值构造函数</strong></p>
<p>　　我们还可以直接使用表值构造函数，这个更加简单直接，代码如下：</p>
<pre class="prettyprint linenums">
insert into new_intervalwaitssample<br />
values<br />
('ASYNC_NETWORK_IO','2011-05-09 16:50:00.973','0.00'),<br />
('ASYNC_NETWORK_IO','2011-05-09 17:00:00.020','0.00'),<br />
('ASYNC_NETWORK_IO','2011-05-09 17:15:00.123','0.00'),<br />
('ASYNC_NETWORK_IO','2011-05-09 17:25:00.190','0.00')
</pre>
<p><strong>　　从表中剪切数据</strong></p>
<p>　　还有一种情况，假设我们想从一个表中的数据删除几条数据，然后把这些删除的数据放到另外一个表中。这个动作就像使用剪切，粘贴一样。不过这种情况要注意，他只能从用户表中剪切数据，不能从视图中剪切数据。它的语法如下</p>
<pre class="prettyprint linenums">
Delete sourcetable<br />
output deleted.value1,deleted.value2,deleted.value3<br />
into targettable<br />
from targettable where
</pre>
<p>　　下面是实例</p>
<pre class="prettyprint linenums">
delete WaitStats<br />
output<br />
deleted.dt,<br />
deleted.wait_type,<br />
deleted.waiting_tasks_count,<br />
deleted.wait_time_ms,<br />
deleted.max_wait_time_ms,<br />
deleted.signal_wait_time_ms<br />
into new_waitestats<br />
where WaitStats.wait_type='ABR'
</pre>
<p>　　要注意的是这里有一个很少见的关键字deleted，它是当前要删除的表的别名，这个有点像类中的this关键字。</p>
<p><strong>　　可见即可得的编辑</strong></p>
<p>　　如果我们是应用程序开发，我相信大多数人还是更愿意使用SQL Server Management<br />
Studio中的图像化界面来操作数据，毕竟提供了这么多强大的功能，为什么不用呢。记得我曾经提到过Oracle中可以直接修改sql语句选择得到的数<br />
据，当时质问Microsoft SQL Server为何没有提供这样强大的功能。呵呵，今天发现SQL<br />
Server还是提供了这样的功能。不过这种修改只能是单独一个表，如果在这个查询语句中有内连接之类的估计就不行了。废话不说，上图：</p>
<ol><li>点击要修改的表右击选择Edit top 200 rows</li>
<li>当打开编辑界面的时候，SQL server上面会多出一个标签<img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/72678/2011051320470694.png" /> ，鼠标滑到这个标签上，再滑到Panel上，再滑到SQL上，点击SQL，或者在编辑界面右击也能看到。如图1<br /><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/72678/2011051320472828.png" /><br />这时候在上面的文字区就可以编写自己想要修改的数据的查询语句如下列：
<pre class="prettyprint linenums">
SELECT TOP (1000) dt, wait_type, waiting_tasks_count, wait_time_ms, max_wait_time_ms, signal_wait_time_ms<br />
FROM         new_waitestats<br />
WHERE     (wait_type ='ABR')
</pre></li>
<li>这里我们想要修改wait_type=ABR的数据，点击查询按钮 ，在下面的表格内就可以看到所有符合条件的数据，这时候就可以修改这些数据了，注意改好之后按回车键才会写到数据库里面。这样做是不是很偷懒呢呵呵，不用写update语句，直接在里面修改。</li></ol>
<p><strong>　　使用编辑器复制粘贴数据</strong></p>
<p>　　还有一种情况可以使用编辑器代替上面的insert into select语句， 如果两个表的字段完全一样，我们从一个表中查询得到数据，然后复制到另外一个表中。</p>
<ol><li>首先点击数据行的开头，选中整行，然后点击copy如图2<br /><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/72678/2011051320510795.png" /></li>
<li>然后右击想要插入数据的第二个表，鼠标拖动滚动条到最后，直到显示一行全部都是空值的一行，然后右击paste，按回车键，这样一条数据就插入进去了。如图3<br /><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/72678/2011051320514341.png" /></li></ol>
<p>　　这些都是在平时工作中见到的，觉得很有意思在这里记录下来。这些雕虫小技对于数据库技术大牛来时不值得一提，还望大牛们看到了不要笑我班门弄斧啊。</p></p></div></p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2wemlq.html">基于redis 实现分布式锁的方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7oxjk8.html">SQL Server 触发器</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1r1668.html">&period;NET正则表达式基础入门（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdly49.html">Activity的保存状态和状态恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/m964lv48.html">WPF自定义空心文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnnp1j8.html">sql类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12n0j9.html">CSS书写规范、顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvgk09.html">语法：MySQL中INSERT INTO SELECT的使用&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e125nx9.html">WPF&mdash;&mdash;传实体类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok03vx9.html">80 多个 Linux 系统管理员的监控工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0vw69.html">关于String和StringBuffer的理解问题：指针、变量的声明、变量的值的变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmk079.html">PHP fpm优化【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvd1lq.html">CentOS 7 x64 安装 Ceph</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdg6ez9.html">写移动端必备的meta标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y2n5g8.html">HBase表重命名</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxelmq.html">MySQL索引介绍&plus;索引的存储类型&plus;索引的优点和缺点&plus;索引的分类&plus;删除索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ey12q.html">php 计算坐标点方圆周围多少米的坐标算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv41yg8.html">C&num;与Excel的交互示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26k0y9.html">Fixation index</a>
		</li>
						<li><a href="https://www.batexi.com/a/95304xv8.html">Android 自定义 ListView 上下拉动&amp;ldquo&semi;刷新最新&amp;rdquo&semi;和&amp;ldquo&semi;加载更多&amp;rdquo&semi;歌曲列表</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj32z79.html">2014多校第一场A题 &vert;&vert; HDU 4861 Couple doubi</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zldg49.html">linux入门教程&lpar;十&rpar; 文档的压缩与打包</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvrn2xq.html">&lbrack;转&rsqb;数据结构之Trie树</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zlnn09.html">LR&lowbar;问题&lowbar;如何将场景中的用户设置为百分比形式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1j7lz9.html">HorseCome</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xwlye8.html">Debug模式应用程序输出Debug调试信息（现成的宏定义，用于格式化打印信息）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mg1wjq.html">39&period; Combination Sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmk3109.html">5、处理模型数据ModelAndView、Map、Model以及&commat;SessionAttributes注解</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xv2kn9.html">Java API &mdash;&mdash; BigDecimal类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm5ore9.html">sh&period;exe&amp;quot&semi;&colon; grunt&colon; command not found</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
